data	segment	page
	I8254_0		equ	220h
	I8254_1		equ	221h
	I8254_2		equ	222h
	I8254_ctr	equ	223h

	I8255_A		EQU	210H
	I8255_C		EQU	212H
	I8255_CTR	EQU	213H
	I8259_0		EQU	200H
	I8259_1		EQU	201H
	in_COUNT	DB	0

	IOAD_S		EQU	230h

	div_num		DB	0
	buf1		DB  'MODE(1~10): ', '$'
	buf2		DB	0DH, 0AH, '$'
    spd_count   DB	0
    buf3		DB  'SPEED: 0x', '$'
    spd_div		DB	0
data	ends

code	segment	page
		assume	cs:code,ds:data
start:	
		mov	ax,	data
		mov	ds,	ax
		
		; TIM0
		mov	dx,	I8254_ctr
		mov	al,	00110110b 
		out	dx,	al
		mov	dx,	I8254_0
		mov	ax,	5000
		out	dx,	al
		mov	al,	ah
		out	dx,	al
		
		; TIM1
		mov	dx,	I8254_ctr
		mov	al,	01110100b 
		out	dx,	al
		mov	dx,	I8254_1
		mov	ax,	10
		out	dx,	al
		mov	al,	ah
		out	dx,	al

		; TIM2, 1Hz
		mov	dx,	I8254_ctr
		mov	al,	10110110b
		out	dx,	al
		mov	dx,	I8254_2
		mov	ax,	200
		out	dx,	al
		mov	al,	ah
		out	dx,	al

		; 8255
		MOV	DX, I8255_CTR
		MOV	AL, 10010000B ;Coutput
		OUT	DX, AL
		MOV	DX, I8255_C
		MOV	AL, in_COUNT
		OUT	DX, AL

		; 8259
		MOV	DX, I8259_0
		MOV	AL, 00010011B ;ICW1
		OUT	DX, AL
		MOV	DX, I8259_1
		MOV	AL, 00110000B ;ICW2, 30IR0
		OUT	DX, AL
		MOV	AL, 00000001B ;ICW4
		OUT	DX, AL

		cli

        ;INTR6
		PUSH DS
		MOV AX, 0
		MOV DS, AX
		LEA AX, CS:INT_PROC2
		MOV SI, 00110110b ;36IR6
		ADD SI, SI
		ADD SI, SI

		MOV DS:[SI], AX
		PUSH CS
		POP AX
		MOV DS:[SI+2], AX
		POP DS

        ;INTR5
		PUSH DS
		MOV	AX,0
		MOV	DS,AX
		LEA	AX,CS:INT_PROC
		MOV	SI,00110101b ;35IR5
		ADD	SI,SI
		ADD	SI,SI

		MOV	DS:[SI],AX
		PUSH CS
		POP	AX
		MOV	DS:[SI+2],AX
		POP	DS

		;OCW2
		MOV	DX, I8259_0
		IN	AL,DX
		AND	AL,10011111b 
		OUT	DX,AL
		
		mov	dx,	IOAD_S
		out	dx,	al
		
		sti
		
wait_loop:
		jmp	wait_loop
	
	
INT_PROC:
		PUSH	DX
		PUSH	AX

		;getADC
		mov	dx,	IOAD_S+1 
		in	al,	dx

		MOV	in_count,AL
		
		mov	ah,	0
		mov	div_num, 28
		div	div_num
		mov	in_COUNT, al
		add	in_COUNT, 2
				
		;LED
		mov	dx, I8255_C
		mov	al, in_COUNT
		call ToRange
		out	dx, al

		;LCDMode
		mov dx, offset buf1
		mov ah, 9
		int 21h
		mov al, in_COUNT
		call ToRange
		call DisplayByte
		call DisplayBlank

        ;LCDSpeed
        mov dx, offset buf3
		mov ah, 9
		int 21h
		mov al, spd_count
		mov ah, 0
		xor dx, dx
		mov spd_div, 6
		div spd_div
		call DisplayHex
		call DisplayBlank
		call DisplayBlank
		call DisplayBlank
		mov spd_count, 0
							
		;8254PWM
		mov	dx,	I8254_ctr
		mov	al,	01110100b 
		out	dx,	al
		mov	dx,	I8254_1
		mov	al,	in_COUNT
		mov	ah,	0
		out	dx,	al
		mov	al,	ah
		out	dx,	al
		
		;EOI
		MOV	DX,I8259_0
		MOV	AL,00100000b
		OUT	DX,AL
			
		mov	dx,	IOAD_S
		out	dx,	al 

		POP	AX
		POP	DX
		sti
		IRET

INT_PROC2:
		inc spd_count
		; EOI
		mov	dx, I8259_0
		mov	al, 00100000b
		out	dx, al
		sti
		iret




H2BCD PROC
		mov ah, 0 
		mov bl, 10
		mov cl, 4
		div bl
		shl al, cl
		or al, ah
		ret
H2BCD ENDP

DisplayByte PROC
		push cx
		push bx
		push ax
		mov  ch, 2
	    call H2BCD
		MOV BL, AL
Loop2:  
		MOV CL, 4
		ROL BL, CL
		mov dl, bl
		and dl, 0FH
		CALL DisplayNum
		DEC CH
		JNZ Loop2
		pop ax
		pop bx
		pop cx
		ret
DisplayByte ENDP

DisplayHex PROC
		push cx
		push bx
		push ax
		mov  ch, 2
		MOV BL, AL
Loop3:  
		MOV CL, 4
		ROL BL, CL
		mov dl, bl
		and dl, 0FH
		CALL DisplayNum
		DEC CH
		JNZ Loop3
		pop ax
		pop bx
		pop cx
		ret
DisplayHex ENDP

DisplayNum PROC 
		ADD DL, 30H
		CMP DL, 39H
		JNA View
		ADD DL, 7
View:   
		MOV AH, 2
		INT 21H
		RET
DisplayNum ENDP

DisplayBlank PROC
		mov dx, offset buf2
		mov ah, 9
		int 21h
		ret
DisplayBlank ENDP

ToRange PROC
		push bx
		sub al, 1
		mov bl, 11
		sub bl, al
		mov al, bl
		pop bx
		ret
ToRange ENDP

code	ends
end		start

